<html>
	<head>
		<TITLE>Nagios - Change Password</TITLE>
	</head>

	<body>

		<h2>Change Password</h2>
		
		<?php 
		/*
			Author:     Terry Carmen, CNY Support LLC.
			Email:      terry@cnysupport.com
			URL:        http://www.cnysupport.com

			Licence:    This software is released under the GPL v3 Licence, available at: http://www.gnu.org/licenses/gpl-3.0.html

			Purpose:    This Nagios add-on allows users to change their own htpasswd-based Nagios passwords.

			Required:   PHP and Apache

			Notes:      This plugin does not enforce any minimum password standards. If you make that enhancement, please let me 
			            know so I can update the add-on on exchange.nagios.org
						
			INSTALLATION INSTRUCTIONS:
			1) Place this file in the directory that maps to your Nagios webroot. On my installation this is: /usr/local/nagios/share
		
			2) Add the line below to the Nagios nav menu. I put mine at the bottom of the list, just above the last "</ul>"
			<li><a href="<?php echo $cfg["webroot"];?>/password.php" target="<?php echo $link_target;?>">Change Password</a></li>
		
			3) Set $passwdfile below to the complete path and filename for your htpasswd.users file. Depending on your specific 
			   installation, you may need to adjust file permissions to allow Apache to write to thre password file.
		*/
		
		$passwdfile='/usr/local/nagios/etc/htpasswd.users';
		
		if (isset($_POST['pw1'])) 
			{
			if( $_POST['pw1'] == $_POST['pw2'] ) 
				{
		
					$user = $_SERVER['PHP_AUTH_USER'];
					$pw1 = $_POST['pw1'];
		
					$htpasswd_text = "";
					for ($i = 0; $i < count ($user); $i++) 
						{					
							$htpasswd_text .= crypt($pw1[$i],CRYPT_STD_DES)."";
						}
					
					
		
					$lines = file($passwdfile) or die("Can't read password file: [" . $passwdfile);
		
					// create $passwdfile with a ~ tacked on. This is our temp file.
					$fh = fopen($passwdfile . "~", 'w') or die("Can't open temporary password file: [". $passwdfile . "~] for writing");
		
					foreach ($lines as $line) 
					{
						$aLine=explode(":", $line);				
						// Ignore any lines that contain things that aren't userid/password combinations
						if(count($aLine) == 2)	
						{	
							// Write out the login									
							if (! fwrite($fh, $aLine[0]))
								die("Unable to output UserID, keeping original file.");	
			
							if (!fwrite($fh, ":"))
								die("Unable to output colon, keeping original file.");	
			
							if ($aLine[0]==$user)				
								{							
									if (!fwrite($fh, $htpasswd_text))
										die("Unable to output new password hash, keeping original file.");								
								}
							else
								{							
									if (!fwrite($fh, $aLine[1]))
										die("Unable to output unmodified user item, keeping original file.");	
								}
							if(!fwrite($fh, "\n"))
								die("Unable to output newline, keeping original file.");	
						}				
					}
		
					fclose($fh);			
		
					if (file_exists($passwdfile."~"))
						{
							unlink ($passwdfile . ".nbku");
							// kill the old .nbku
				
							rename ($passwdfile, $passwdfile . ".nbku");
							// rename the current file to .nbku
				
							rename ($passwdfile."~", $passwdfile);
							// rename the ~ file to $passwdfile
				
							echo "Password Changed";
						}
					else
						echo "New htaccess file does not exist! Keeping original";
		
				} 
			else 
				{
					echo "<strong>Passwords do not match. Please click the [Back] button and try again.<strong>";
				}
			}
		else
			{
			?>
				<FORM METHOD="POST" ACTION="<? echo $_SERVER['PHP_SELF']; ?>" onSubmit='return ValidateForm()'>
					<table>
				
						<TR>
							<TD align="right">Changing Password For:</TD>
							<TD style="font-weight:bold;"><?php echo $_SERVER['PHP_AUTH_USER']; ?></TD>
						</TR>
						<TR>
							<TD align="right">New Password:</TD>
							<TD><INPUT TYPE="PASSWORD" NAME="pw1[]"></TD>
						</TR>
						<TR>
							<TD align="right">New Password Again:</TD>
							<TD><INPUT TYPE="PASSWORD" NAME="pw2[]"></TD>
						</TR>
						<tr><TD align="right" colspan="2"><INPUT type=submit name="submit" VALUE="Save" onclick="document.all.submit.style.visibility='hidden'"></TD></tr>
					</table>
				</FORM>
			<?php
			}
			?>
	</body>
</html>
